# dxb Channel

dxb Channel is a test [channel for Roku devices](https://sdkdocs.roku.com/display/sdkdoc/SceneGraph+Samples).
It uses SceneGraph and the BrightScript language.

## Getting The Channel

This is the private channel code: **[dxb](https://my.roku.com/add/dxb)**

Clicking the link will take you directly to a confirmation page for getting the channel.

## Preview

![dxb channel screenshot](https://dlma.com/images/dxb_channel/dxb_screenshot.jpg)

# Getting the project

At [git.dlma.com](https://git.dlma.com/dxb_channel.git) click Download and
select Download ZIP or Download TAR.

If you're me, and you want to contribute to the repo, then you can clone it like so:

    git clone ssh://$USER@dlma.com/~/git/dxb_channel.git

## Building it

[Ensure you can sideload a dev channel](https://sdkdocs.roku.com/display/sdkdoc/Loading+and+Running+Your+Application).

It is convenient to set environment variables `$ROKU_DEV_TARGET` and `$DEVPASSWORD` in a
local file ".env". For example:

    ROKU_DEV_TARGET=192.168.1.2
    DEVPASSWORD=mooltipass

### CLI

Running make will build and deploy if you have `$ROKU_DEV_TARGET` and `$DEVPASSWORD` set.

    make

You can automatically make and deploy with each changed file with the following command:

    git ls-files | entr -c sh -c 'make all'

### VS Code

VS Code can also use the Makefile with
[VC Code Makefile Tools](https://marketplace.visualstudio.com/items?itemName=ms-vscode.makefile-tools).

Use dxb\_channel.code-workspace as your workspace file for the project.

### Sublime Text

See the "build\_systems" command in dxb\_channel.sublime-project to see how
the channel is zipped and deployed.

## Experimenting

The code in [`components/testtask.brs`](https://git.dlma.com/dxb_channel.git/blob/main/components/testtask.brs)
is run every time the OK button is pressed (while the "Test Output" pane has
focus).  That's a good place to experiment with new code.

# Is it any good?

[Yes](https://news.ycombinator.com/item?id=3067434).

# Licence

This software uses the [MIT license](https://git.dlma.com/dxb_channel.git/blob/main/LICENSE.txt).
